<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Source of the Rust file `/nix/store/kaan79bbbx80h17lcc5ay919l5r6bqlz-vendored-sources/aho-corasick-0.7.18/src/classes.rs`."><meta name="keywords" content="rust, rustlang, rust-lang"><title>classes.rs - source</title><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceSerif4-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../FiraSans-Regular.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../FiraSans-Medium.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceCodePro-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceSerif4-Bold.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceCodePro-Semibold.ttf.woff2"><link rel="stylesheet" type="text/css" href="../../normalize.css"><link rel="stylesheet" type="text/css" href="../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../ayu.css" disabled><link rel="stylesheet" type="text/css" href="../../dark.css" disabled><link rel="stylesheet" type="text/css" href="../../light.css" id="themeStyle"><script id="default-settings" ></script><script src="../../storage.js"></script><script defer src="../../source-script.js"></script><script defer src="../../source-files.js"></script><script defer src="../../main.js"></script><noscript><link rel="stylesheet" href="../../noscript.css"></noscript><link rel="alternate icon" type="image/png" href="../../favicon-16x16.png"><link rel="alternate icon" type="image/png" href="../../favicon-32x32.png"><link rel="icon" type="image/svg+xml" href="../../favicon.svg"></head><body class="rustdoc source"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="mobile-topbar"><button class="sidebar-menu-toggle">&#9776;</button><a class="sidebar-logo" href="../../aho_corasick/index.html"><div class="logo-container"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></div>
        </a><h2 class="location"></h2>
    </nav>
    <nav class="sidebar"><a class="sidebar-logo" href="../../aho_corasick/index.html"><div class="logo-container"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></div>
        </a></nav><main><div class="width-limiter"><div class="sub-container"><a class="sub-logo-container" href="../../aho_corasick/index.html"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></a><nav class="sub"><form class="search-form"><div class="search-container"><span></span><input class="search-input" name="search" autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"><div id="help-button" title="help" tabindex="-1"><button type="button">?</button></div><div id="settings-menu" tabindex="-1">
                                <a href="../../settings.html" title="settings"><img width="22" height="22" alt="Change settings" src="../../wheel.svg"></a></div>
                        </div></form></nav></div><section id="main-content" class="content"><div class="example-wrap"><pre class="line-numbers"><span id="1">1</span>
<span id="2">2</span>
<span id="3">3</span>
<span id="4">4</span>
<span id="5">5</span>
<span id="6">6</span>
<span id="7">7</span>
<span id="8">8</span>
<span id="9">9</span>
<span id="10">10</span>
<span id="11">11</span>
<span id="12">12</span>
<span id="13">13</span>
<span id="14">14</span>
<span id="15">15</span>
<span id="16">16</span>
<span id="17">17</span>
<span id="18">18</span>
<span id="19">19</span>
<span id="20">20</span>
<span id="21">21</span>
<span id="22">22</span>
<span id="23">23</span>
<span id="24">24</span>
<span id="25">25</span>
<span id="26">26</span>
<span id="27">27</span>
<span id="28">28</span>
<span id="29">29</span>
<span id="30">30</span>
<span id="31">31</span>
<span id="32">32</span>
<span id="33">33</span>
<span id="34">34</span>
<span id="35">35</span>
<span id="36">36</span>
<span id="37">37</span>
<span id="38">38</span>
<span id="39">39</span>
<span id="40">40</span>
<span id="41">41</span>
<span id="42">42</span>
<span id="43">43</span>
<span id="44">44</span>
<span id="45">45</span>
<span id="46">46</span>
<span id="47">47</span>
<span id="48">48</span>
<span id="49">49</span>
<span id="50">50</span>
<span id="51">51</span>
<span id="52">52</span>
<span id="53">53</span>
<span id="54">54</span>
<span id="55">55</span>
<span id="56">56</span>
<span id="57">57</span>
<span id="58">58</span>
<span id="59">59</span>
<span id="60">60</span>
<span id="61">61</span>
<span id="62">62</span>
<span id="63">63</span>
<span id="64">64</span>
<span id="65">65</span>
<span id="66">66</span>
<span id="67">67</span>
<span id="68">68</span>
<span id="69">69</span>
<span id="70">70</span>
<span id="71">71</span>
<span id="72">72</span>
<span id="73">73</span>
<span id="74">74</span>
<span id="75">75</span>
<span id="76">76</span>
<span id="77">77</span>
<span id="78">78</span>
<span id="79">79</span>
<span id="80">80</span>
<span id="81">81</span>
<span id="82">82</span>
<span id="83">83</span>
<span id="84">84</span>
<span id="85">85</span>
<span id="86">86</span>
<span id="87">87</span>
<span id="88">88</span>
<span id="89">89</span>
<span id="90">90</span>
<span id="91">91</span>
<span id="92">92</span>
<span id="93">93</span>
<span id="94">94</span>
<span id="95">95</span>
<span id="96">96</span>
<span id="97">97</span>
<span id="98">98</span>
<span id="99">99</span>
<span id="100">100</span>
<span id="101">101</span>
<span id="102">102</span>
<span id="103">103</span>
<span id="104">104</span>
<span id="105">105</span>
<span id="106">106</span>
<span id="107">107</span>
<span id="108">108</span>
<span id="109">109</span>
<span id="110">110</span>
<span id="111">111</span>
<span id="112">112</span>
<span id="113">113</span>
<span id="114">114</span>
<span id="115">115</span>
<span id="116">116</span>
<span id="117">117</span>
<span id="118">118</span>
<span id="119">119</span>
<span id="120">120</span>
<span id="121">121</span>
<span id="122">122</span>
<span id="123">123</span>
<span id="124">124</span>
<span id="125">125</span>
<span id="126">126</span>
<span id="127">127</span>
<span id="128">128</span>
<span id="129">129</span>
<span id="130">130</span>
<span id="131">131</span>
<span id="132">132</span>
<span id="133">133</span>
<span id="134">134</span>
<span id="135">135</span>
<span id="136">136</span>
<span id="137">137</span>
<span id="138">138</span>
<span id="139">139</span>
<span id="140">140</span>
<span id="141">141</span>
<span id="142">142</span>
<span id="143">143</span>
<span id="144">144</span>
<span id="145">145</span>
<span id="146">146</span>
<span id="147">147</span>
<span id="148">148</span>
<span id="149">149</span>
<span id="150">150</span>
<span id="151">151</span>
<span id="152">152</span>
<span id="153">153</span>
<span id="154">154</span>
<span id="155">155</span>
<span id="156">156</span>
<span id="157">157</span>
<span id="158">158</span>
<span id="159">159</span>
<span id="160">160</span>
<span id="161">161</span>
<span id="162">162</span>
<span id="163">163</span>
<span id="164">164</span>
<span id="165">165</span>
<span id="166">166</span>
<span id="167">167</span>
<span id="168">168</span>
<span id="169">169</span>
<span id="170">170</span>
<span id="171">171</span>
<span id="172">172</span>
<span id="173">173</span>
<span id="174">174</span>
<span id="175">175</span>
<span id="176">176</span>
<span id="177">177</span>
<span id="178">178</span>
<span id="179">179</span>
<span id="180">180</span>
<span id="181">181</span>
<span id="182">182</span>
<span id="183">183</span>
<span id="184">184</span>
<span id="185">185</span>
<span id="186">186</span>
<span id="187">187</span>
<span id="188">188</span>
<span id="189">189</span>
<span id="190">190</span>
<span id="191">191</span>
<span id="192">192</span>
<span id="193">193</span>
<span id="194">194</span>
<span id="195">195</span>
<span id="196">196</span>
<span id="197">197</span>
<span id="198">198</span>
<span id="199">199</span>
<span id="200">200</span>
<span id="201">201</span>
<span id="202">202</span>
<span id="203">203</span>
<span id="204">204</span>
<span id="205">205</span>
<span id="206">206</span>
<span id="207">207</span>
<span id="208">208</span>
<span id="209">209</span>
<span id="210">210</span>
<span id="211">211</span>
<span id="212">212</span>
<span id="213">213</span>
<span id="214">214</span>
<span id="215">215</span>
<span id="216">216</span>
<span id="217">217</span>
<span id="218">218</span>
<span id="219">219</span>
<span id="220">220</span>
<span id="221">221</span>
<span id="222">222</span>
<span id="223">223</span>
<span id="224">224</span>
<span id="225">225</span>
<span id="226">226</span>
<span id="227">227</span>
<span id="228">228</span>
<span id="229">229</span>
<span id="230">230</span>
<span id="231">231</span>
<span id="232">232</span>
<span id="233">233</span>
<span id="234">234</span>
<span id="235">235</span>
<span id="236">236</span>
<span id="237">237</span>
<span id="238">238</span>
</pre><pre class="rust"><code><span class="kw">use</span> <span class="ident">std::fmt</span>;

<span class="doccomment">/// A representation of byte oriented equivalence classes.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// This is used in an FSM to reduce the size of the transition table. This can</span>
<span class="doccomment">/// have a particularly large impact not only on the total size of an FSM, but</span>
<span class="doccomment">/// also on compile times.</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Clone</span>, <span class="ident">Copy</span>)]</span>
<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">ByteClasses</span>([<span class="ident">u8</span>; <span class="number">256</span>]);

<span class="kw">impl</span> <span class="ident">ByteClasses</span> {
    <span class="doccomment">/// Creates a new set of equivalence classes where all bytes are mapped to</span>
    <span class="doccomment">/// the same class.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">empty</span>() -&gt; <span class="ident">ByteClasses</span> {
        <span class="ident">ByteClasses</span>([<span class="number">0</span>; <span class="number">256</span>])
    }

    <span class="doccomment">/// Creates a new set of equivalence classes where each byte belongs to</span>
    <span class="doccomment">/// its own equivalence class.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">singletons</span>() -&gt; <span class="ident">ByteClasses</span> {
        <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">classes</span> <span class="op">=</span> <span class="ident">ByteClasses::empty</span>();
        <span class="kw">for</span> <span class="ident">i</span> <span class="kw">in</span> <span class="number">0</span>..<span class="number">256</span> {
            <span class="ident">classes</span>.<span class="ident">set</span>(<span class="ident">i</span> <span class="kw">as</span> <span class="ident">u8</span>, <span class="ident">i</span> <span class="kw">as</span> <span class="ident">u8</span>);
        }
        <span class="ident">classes</span>
    }

    <span class="doccomment">/// Set the equivalence class for the given byte.</span>
    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">set</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>, <span class="ident">byte</span>: <span class="ident">u8</span>, <span class="ident">class</span>: <span class="ident">u8</span>) {
        <span class="self">self</span>.<span class="number">0</span>[<span class="ident">byte</span> <span class="kw">as</span> <span class="ident">usize</span>] <span class="op">=</span> <span class="ident">class</span>;
    }

    <span class="doccomment">/// Get the equivalence class for the given byte.</span>
    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">get</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">byte</span>: <span class="ident">u8</span>) -&gt; <span class="ident">u8</span> {
        <span class="comment">// SAFETY: This is safe because all dense transitions have</span>
        <span class="comment">// exactly 256 elements, so all u8 values are valid indices.</span>
        <span class="self">self</span>.<span class="number">0</span>[<span class="ident">byte</span> <span class="kw">as</span> <span class="ident">usize</span>]
    }

    <span class="doccomment">/// Return the total number of elements in the alphabet represented by</span>
    <span class="doccomment">/// these equivalence classes. Equivalently, this returns the total number</span>
    <span class="doccomment">/// of equivalence classes.</span>
    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">alphabet_len</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="ident">usize</span> {
        <span class="self">self</span>.<span class="number">0</span>[<span class="number">255</span>] <span class="kw">as</span> <span class="ident">usize</span> <span class="op">+</span> <span class="number">1</span>
    }

    <span class="doccomment">/// Returns true if and only if every byte in this class maps to its own</span>
    <span class="doccomment">/// equivalence class. Equivalently, there are 256 equivalence classes</span>
    <span class="doccomment">/// and each class contains exactly one byte.</span>
    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">is_singleton</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="ident">bool</span> {
        <span class="self">self</span>.<span class="ident">alphabet_len</span>() <span class="op">==</span> <span class="number">256</span>
    }

    <span class="doccomment">/// Returns an iterator over a sequence of representative bytes from each</span>
    <span class="doccomment">/// equivalence class. Namely, this yields exactly N items, where N is</span>
    <span class="doccomment">/// equivalent to the number of equivalence classes. Each item is an</span>
    <span class="doccomment">/// arbitrary byte drawn from each equivalence class.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// This is useful when one is determinizing an NFA and the NFA&#39;s alphabet</span>
    <span class="doccomment">/// hasn&#39;t been converted to equivalence classes yet. Picking an arbitrary</span>
    <span class="doccomment">/// byte from each equivalence class then permits a full exploration of</span>
    <span class="doccomment">/// the NFA instead of using every possible byte value.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">representatives</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="ident">ByteClassRepresentatives</span><span class="op">&lt;</span><span class="lifetime">&#39;_</span><span class="op">&gt;</span> {
        <span class="ident">ByteClassRepresentatives</span> { <span class="ident">classes</span>: <span class="self">self</span>, <span class="ident">byte</span>: <span class="number">0</span>, <span class="ident">last_class</span>: <span class="prelude-val">None</span> }
    }

    <span class="doccomment">/// Returns all of the bytes in the given equivalence class.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// The second element in the tuple indicates the number of elements in</span>
    <span class="doccomment">/// the array.</span>
    <span class="kw">fn</span> <span class="ident">elements</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">equiv</span>: <span class="ident">u8</span>) -&gt; ([<span class="ident">u8</span>; <span class="number">256</span>], <span class="ident">usize</span>) {
        <span class="kw">let</span> (<span class="kw-2">mut</span> <span class="ident">array</span>, <span class="kw-2">mut</span> <span class="ident">len</span>) <span class="op">=</span> ([<span class="number">0</span>; <span class="number">256</span>], <span class="number">0</span>);
        <span class="kw">for</span> <span class="ident">b</span> <span class="kw">in</span> <span class="number">0</span>..<span class="number">256</span> {
            <span class="kw">if</span> <span class="self">self</span>.<span class="ident">get</span>(<span class="ident">b</span> <span class="kw">as</span> <span class="ident">u8</span>) <span class="op">==</span> <span class="ident">equiv</span> {
                <span class="ident">array</span>[<span class="ident">len</span>] <span class="op">=</span> <span class="ident">b</span> <span class="kw">as</span> <span class="ident">u8</span>;
                <span class="ident">len</span> <span class="op">+</span><span class="op">=</span> <span class="number">1</span>;
            }
        }
        (<span class="ident">array</span>, <span class="ident">len</span>)
    }
}

<span class="kw">impl</span> <span class="ident">fmt::Debug</span> <span class="kw">for</span> <span class="ident">ByteClasses</span> {
    <span class="kw">fn</span> <span class="ident">fmt</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">f</span>: <span class="kw-2">&amp;mut</span> <span class="ident">fmt::Formatter</span><span class="op">&lt;</span><span class="lifetime">&#39;_</span><span class="op">&gt;</span>) -&gt; <span class="ident">fmt::Result</span> {
        <span class="kw">if</span> <span class="self">self</span>.<span class="ident">is_singleton</span>() {
            <span class="macro">write!</span>(<span class="ident">f</span>, <span class="string">&quot;ByteClasses({{singletons}})&quot;</span>)
        } <span class="kw">else</span> {
            <span class="macro">write!</span>(<span class="ident">f</span>, <span class="string">&quot;ByteClasses(&quot;</span>)<span class="question-mark">?</span>;
            <span class="kw">for</span> <span class="ident">equiv</span> <span class="kw">in</span> <span class="number">0</span>..<span class="self">self</span>.<span class="ident">alphabet_len</span>() {
                <span class="kw">let</span> (<span class="ident">members</span>, <span class="ident">len</span>) <span class="op">=</span> <span class="self">self</span>.<span class="ident">elements</span>(<span class="ident">equiv</span> <span class="kw">as</span> <span class="ident">u8</span>);
                <span class="macro">write!</span>(<span class="ident">f</span>, <span class="string">&quot; {} =&gt; {:?}&quot;</span>, <span class="ident">equiv</span>, <span class="kw-2">&amp;</span><span class="ident">members</span>[..<span class="ident">len</span>])<span class="question-mark">?</span>;
            }
            <span class="macro">write!</span>(<span class="ident">f</span>, <span class="string">&quot;)&quot;</span>)
        }
    }
}

<span class="doccomment">/// An iterator over representative bytes from each equivalence class.</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Debug</span>)]</span>
<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">ByteClassRepresentatives</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span><span class="op">&gt;</span> {
    <span class="ident">classes</span>: <span class="kw-2">&amp;</span><span class="lifetime">&#39;a</span> <span class="ident">ByteClasses</span>,
    <span class="ident">byte</span>: <span class="ident">usize</span>,
    <span class="ident">last_class</span>: <span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="ident">u8</span><span class="op">&gt;</span>,
}

<span class="kw">impl</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span><span class="op">&gt;</span> <span class="ident">Iterator</span> <span class="kw">for</span> <span class="ident">ByteClassRepresentatives</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span><span class="op">&gt;</span> {
    <span class="kw">type</span> <span class="ident">Item</span> <span class="op">=</span> <span class="ident">u8</span>;

    <span class="kw">fn</span> <span class="ident">next</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>) -&gt; <span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="ident">u8</span><span class="op">&gt;</span> {
        <span class="kw">while</span> <span class="self">self</span>.<span class="ident">byte</span> <span class="op">&lt;</span> <span class="number">256</span> {
            <span class="kw">let</span> <span class="ident">byte</span> <span class="op">=</span> <span class="self">self</span>.<span class="ident">byte</span> <span class="kw">as</span> <span class="ident">u8</span>;
            <span class="kw">let</span> <span class="ident">class</span> <span class="op">=</span> <span class="self">self</span>.<span class="ident">classes</span>.<span class="ident">get</span>(<span class="ident">byte</span>);
            <span class="self">self</span>.<span class="ident">byte</span> <span class="op">+</span><span class="op">=</span> <span class="number">1</span>;

            <span class="kw">if</span> <span class="self">self</span>.<span class="ident">last_class</span> <span class="op">!</span><span class="op">=</span> <span class="prelude-val">Some</span>(<span class="ident">class</span>) {
                <span class="self">self</span>.<span class="ident">last_class</span> <span class="op">=</span> <span class="prelude-val">Some</span>(<span class="ident">class</span>);
                <span class="kw">return</span> <span class="prelude-val">Some</span>(<span class="ident">byte</span>);
            }
        }
        <span class="prelude-val">None</span>
    }
}

<span class="doccomment">/// A byte class builder keeps track of an *approximation* of equivalence</span>
<span class="doccomment">/// classes of bytes during NFA construction. That is, every byte in an</span>
<span class="doccomment">/// equivalence class cannot discriminate between a match and a non-match.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// For example, in the literals `abc` and `xyz`, the bytes [\x00-`], [d-w]</span>
<span class="doccomment">/// and [{-\xFF] never discriminate between a match and a non-match, precisely</span>
<span class="doccomment">/// because they never occur in the literals anywhere.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// Note though that this does not necessarily compute the minimal set of</span>
<span class="doccomment">/// equivalence classes. For example, in the literals above, the byte ranges</span>
<span class="doccomment">/// [\x00-`], [d-w] and [{-\xFF] are all treated as distinct equivalence</span>
<span class="doccomment">/// classes even though they could be treated a single class. The reason for</span>
<span class="doccomment">/// this is implementation complexity. In the future, we should endeavor to</span>
<span class="doccomment">/// compute the minimal equivalence classes since they can have a rather large</span>
<span class="doccomment">/// impact on the size of the DFA.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// The representation here is 256 booleans, all initially set to false. Each</span>
<span class="doccomment">/// boolean maps to its corresponding byte based on position. A `true` value</span>
<span class="doccomment">/// indicates the end of an equivalence class, where its corresponding byte</span>
<span class="doccomment">/// and all of the bytes corresponding to all previous contiguous `false`</span>
<span class="doccomment">/// values are in the same equivalence class.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// This particular representation only permits contiguous ranges of bytes to</span>
<span class="doccomment">/// be in the same equivalence class, which means that we can never discover</span>
<span class="doccomment">/// the true minimal set of equivalence classes.</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Debug</span>)]</span>
<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">ByteClassBuilder</span>(<span class="ident">Vec</span><span class="op">&lt;</span><span class="ident">bool</span><span class="op">&gt;</span>);

<span class="kw">impl</span> <span class="ident">ByteClassBuilder</span> {
    <span class="doccomment">/// Create a new builder of byte classes where all bytes are part of the</span>
    <span class="doccomment">/// same equivalence class.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">new</span>() -&gt; <span class="ident">ByteClassBuilder</span> {
        <span class="ident">ByteClassBuilder</span>(<span class="macro">vec!</span>[<span class="bool-val">false</span>; <span class="number">256</span>])
    }

    <span class="doccomment">/// Indicate the the range of byte given (inclusive) can discriminate a</span>
    <span class="doccomment">/// match between it and all other bytes outside of the range.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">set_range</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>, <span class="ident">start</span>: <span class="ident">u8</span>, <span class="ident">end</span>: <span class="ident">u8</span>) {
        <span class="macro">debug_assert!</span>(<span class="ident">start</span> <span class="op">&lt;</span><span class="op">=</span> <span class="ident">end</span>);
        <span class="kw">if</span> <span class="ident">start</span> <span class="op">&gt;</span> <span class="number">0</span> {
            <span class="self">self</span>.<span class="number">0</span>[<span class="ident">start</span> <span class="kw">as</span> <span class="ident">usize</span> <span class="op">-</span> <span class="number">1</span>] <span class="op">=</span> <span class="bool-val">true</span>;
        }
        <span class="self">self</span>.<span class="number">0</span>[<span class="ident">end</span> <span class="kw">as</span> <span class="ident">usize</span>] <span class="op">=</span> <span class="bool-val">true</span>;
    }

    <span class="doccomment">/// Build byte classes that map all byte values to their corresponding</span>
    <span class="doccomment">/// equivalence class. The last mapping indicates the largest equivalence</span>
    <span class="doccomment">/// class identifier (which is never bigger than 255).</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">build</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="ident">ByteClasses</span> {
        <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">classes</span> <span class="op">=</span> <span class="ident">ByteClasses::empty</span>();
        <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">class</span> <span class="op">=</span> <span class="number">0u8</span>;
        <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">i</span> <span class="op">=</span> <span class="number">0</span>;
        <span class="kw">loop</span> {
            <span class="ident">classes</span>.<span class="ident">set</span>(<span class="ident">i</span> <span class="kw">as</span> <span class="ident">u8</span>, <span class="ident">class</span> <span class="kw">as</span> <span class="ident">u8</span>);
            <span class="kw">if</span> <span class="ident">i</span> <span class="op">&gt;</span><span class="op">=</span> <span class="number">255</span> {
                <span class="kw">break</span>;
            }
            <span class="kw">if</span> <span class="self">self</span>.<span class="number">0</span>[<span class="ident">i</span>] {
                <span class="ident">class</span> <span class="op">=</span> <span class="ident">class</span>.<span class="ident">checked_add</span>(<span class="number">1</span>).<span class="ident">unwrap</span>();
            }
            <span class="ident">i</span> <span class="op">+</span><span class="op">=</span> <span class="number">1</span>;
        }
        <span class="ident">classes</span>
    }
}

<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">test</span>)]</span>
<span class="kw">mod</span> <span class="ident">tests</span> {
    <span class="kw">use</span> <span class="kw">super</span>::<span class="kw-2">*</span>;

    <span class="attribute">#[<span class="ident">test</span>]</span>
    <span class="kw">fn</span> <span class="ident">byte_classes</span>() {
        <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">set</span> <span class="op">=</span> <span class="ident">ByteClassBuilder::new</span>();
        <span class="ident">set</span>.<span class="ident">set_range</span>(<span class="string">b&#39;a&#39;</span>, <span class="string">b&#39;z&#39;</span>);

        <span class="kw">let</span> <span class="ident">classes</span> <span class="op">=</span> <span class="ident">set</span>.<span class="ident">build</span>();
        <span class="macro">assert_eq!</span>(<span class="ident">classes</span>.<span class="ident">get</span>(<span class="number">0</span>), <span class="number">0</span>);
        <span class="macro">assert_eq!</span>(<span class="ident">classes</span>.<span class="ident">get</span>(<span class="number">1</span>), <span class="number">0</span>);
        <span class="macro">assert_eq!</span>(<span class="ident">classes</span>.<span class="ident">get</span>(<span class="number">2</span>), <span class="number">0</span>);
        <span class="macro">assert_eq!</span>(<span class="ident">classes</span>.<span class="ident">get</span>(<span class="string">b&#39;a&#39;</span> <span class="op">-</span> <span class="number">1</span>), <span class="number">0</span>);
        <span class="macro">assert_eq!</span>(<span class="ident">classes</span>.<span class="ident">get</span>(<span class="string">b&#39;a&#39;</span>), <span class="number">1</span>);
        <span class="macro">assert_eq!</span>(<span class="ident">classes</span>.<span class="ident">get</span>(<span class="string">b&#39;m&#39;</span>), <span class="number">1</span>);
        <span class="macro">assert_eq!</span>(<span class="ident">classes</span>.<span class="ident">get</span>(<span class="string">b&#39;z&#39;</span>), <span class="number">1</span>);
        <span class="macro">assert_eq!</span>(<span class="ident">classes</span>.<span class="ident">get</span>(<span class="string">b&#39;z&#39;</span> <span class="op">+</span> <span class="number">1</span>), <span class="number">2</span>);
        <span class="macro">assert_eq!</span>(<span class="ident">classes</span>.<span class="ident">get</span>(<span class="number">254</span>), <span class="number">2</span>);
        <span class="macro">assert_eq!</span>(<span class="ident">classes</span>.<span class="ident">get</span>(<span class="number">255</span>), <span class="number">2</span>);

        <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">set</span> <span class="op">=</span> <span class="ident">ByteClassBuilder::new</span>();
        <span class="ident">set</span>.<span class="ident">set_range</span>(<span class="number">0</span>, <span class="number">2</span>);
        <span class="ident">set</span>.<span class="ident">set_range</span>(<span class="number">4</span>, <span class="number">6</span>);
        <span class="kw">let</span> <span class="ident">classes</span> <span class="op">=</span> <span class="ident">set</span>.<span class="ident">build</span>();
        <span class="macro">assert_eq!</span>(<span class="ident">classes</span>.<span class="ident">get</span>(<span class="number">0</span>), <span class="number">0</span>);
        <span class="macro">assert_eq!</span>(<span class="ident">classes</span>.<span class="ident">get</span>(<span class="number">1</span>), <span class="number">0</span>);
        <span class="macro">assert_eq!</span>(<span class="ident">classes</span>.<span class="ident">get</span>(<span class="number">2</span>), <span class="number">0</span>);
        <span class="macro">assert_eq!</span>(<span class="ident">classes</span>.<span class="ident">get</span>(<span class="number">3</span>), <span class="number">1</span>);
        <span class="macro">assert_eq!</span>(<span class="ident">classes</span>.<span class="ident">get</span>(<span class="number">4</span>), <span class="number">2</span>);
        <span class="macro">assert_eq!</span>(<span class="ident">classes</span>.<span class="ident">get</span>(<span class="number">5</span>), <span class="number">2</span>);
        <span class="macro">assert_eq!</span>(<span class="ident">classes</span>.<span class="ident">get</span>(<span class="number">6</span>), <span class="number">2</span>);
        <span class="macro">assert_eq!</span>(<span class="ident">classes</span>.<span class="ident">get</span>(<span class="number">7</span>), <span class="number">3</span>);
        <span class="macro">assert_eq!</span>(<span class="ident">classes</span>.<span class="ident">get</span>(<span class="number">255</span>), <span class="number">3</span>);
    }

    <span class="attribute">#[<span class="ident">test</span>]</span>
    <span class="kw">fn</span> <span class="ident">full_byte_classes</span>() {
        <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">set</span> <span class="op">=</span> <span class="ident">ByteClassBuilder::new</span>();
        <span class="kw">for</span> <span class="ident">i</span> <span class="kw">in</span> <span class="number">0</span>..<span class="number">256u16</span> {
            <span class="ident">set</span>.<span class="ident">set_range</span>(<span class="ident">i</span> <span class="kw">as</span> <span class="ident">u8</span>, <span class="ident">i</span> <span class="kw">as</span> <span class="ident">u8</span>);
        }
        <span class="macro">assert_eq!</span>(<span class="ident">set</span>.<span class="ident">build</span>().<span class="ident">alphabet_len</span>(), <span class="number">256</span>);
    }
}
</code></pre></div>
</section></div></main><div id="rustdoc-vars" data-root-path="../../" data-current-crate="aho_corasick" data-themes="ayu,dark,light" data-resource-suffix="" data-rustdoc-version="1.64.0-dev" ></div>
</body></html>